



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++中的trivial解释</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++中的trivial解释</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:35:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Trivial default constructor</strong></p>
<p>The default constructor for class T is trivial (i.e. performs no action) if all of the following is true:</p>
<ul><li>The constructor is not user-provided (i.e., is implicitly-defined or defaulted)</li>
<li>T has no virtual member functions</li>
<li>T has no virtual base classes</li>
<li>T has no non-static members with default initializers.(since C++11)</li>
<li>Every direct base of T has a trivial default constructor</li>
<li>Every non-static member of class type has a trivial default constructor</li></ul>
<p>A trivial default constructor is a constructor that performs no action. Objects with trivial default constructors can be created by using reinterpret_cast on any suitably aligned storage, e.g. on memory allocated with std::malloc. All data types compatible with the C language (POD types) are trivially default-constructible.</p>
<p>1）什么时候才会合成出一个default constructor呢？当编译器需要它的时候！此外，被合成出来的constructor只执行编译器所需的行动。<br />
2）如果已经存在constructors，那么编译器会扩张已存在的constructors，在其中安插一些代码，使得user code被执行之前，先调用必要的default constructors。<br />
3）如果设计者提供了多个constructors，但没有提供default constructor，这时编译器不会合成一个新的default constructor，因为其他“由user所提供的constructors”存在的缘故。</p>
<hr />
<p><strong>Trivial copy constructor</strong></p>
<p>The copy constructor for class T is trivial if all of the following is true:</p>
<ul><li>it is not user-provided (that is, it is implicitly-defined or defaulted), and if it is defaulted, its signature is the same as implicitly-defined (until C++14);</li>
<li>T has no virtual member functions;</li>
<li>T has no virtual base classes;</li>
<li>the copy constructor selected for every direct base of T is trivial;</li>
<li>the copy constructor selected for every non-static class type (or array of class type) member of T is trivial;</li>
<li>T has no non-static data members of volatile-qualified type.(since C++14)</li></ul>
<p>A trivial copy constructor is a constructor that creates a bytewise copy of the object representation of the argument, and performs no other action. Objects with trivial copy constructors can be copied by copying their object representations manually, e.g. with std::memmove. All data types compatible with the C language (POD types) are trivially copyable.</p>
<hr />
<p><strong>Trivial destructor</strong></p>
<p>The destructor for class T is trivial if all of the following is true:</p>
<ul><li>The destructor is not user-provided (meaning, it is either implicitly declared, or explicitly defined as defaulted on its first declaration)</li>
<li>The destructor is not virtual (that is, the base class destructor is not virtual)</li>
<li>All direct base classes have trivial destructors</li>
<li>All non-static data members of class type (or array of class type) have trivial destructors</li></ul>
<p>A trivial destructor is a destructor that performs no action. Objects with trivial destructors don't require a delete-expression and may be disposed of by simply deallocating their storage. All data types compatible with the C language (POD types) are trivially destructible.</p>
<p>参考：cppreference.com</p>
<p>详细请参考：《深度探索C++对象模型》，不过需要注意的是shallow copy = bitwise copy与deep copy = memberwise copy。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlnwz08.html">poj 1266 Cover an Arc&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gy6509.html">ZOJ 3781 Paint the Grid Reloaded（BFS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyj1lgq.html">使用window&period;print实现网页打印</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5v7w8.html">AloneJs&period;confirmbox&lpar;&rpar; &mdash;&mdash; 确认框</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7k1mj9.html">android 进程间通信---Service Manager（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv50ozq.html">《C语言入门1&period;2&period;3&mdash;一个老鸟的C语言学习心得》&mdash;清华大学出版社炮制的又一本劣书及伪书</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15xn79.html">ADO&period;NET笔记&mdash;&mdash;使用Connection连接数据库，使用Command对象的ExecuteReader&lpar;&rpar;方法创建DataReader对象返回多行数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zx7g49.html">关于C&num;与&period;NET Framework</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm72j9.html">调用函数的ALV、面向对象的ALV设置带选择列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejlmz8.html">C&num;中WindowsForm常见控件的运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj33k5q.html">团队作业8&mdash;&mdash;第二次项目冲刺（Beta阶段）日志集合处</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j4epo8.html">【CF932E】Perpetual Subtraction（NTT，线性代数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rv2608.html">安装完最小化 RHEL&sol;CentOS 7 后需要做的 30 件事情（一）转载自码农网</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgmek8.html">通俗bandit算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyo05gq.html">【代码笔记】Web-HTML-链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpxpez9.html">【BZOJ1045】糖果传递（贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vn4d5q.html">生成CFree 5&period;0 注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd5mg1q.html">python爬虫之下载京东页面图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77x5vxq.html">django自强学堂地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zv1l739.html">在window上使用eclipse对hadoop进行编程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdkn579.html">时间轴CSS的Demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p7ol38.html">Ubuntu安装pycharm</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mele36q.html">添加&amp;lt&semi;&excl;doctype html&amp;gt&semi;后造成JS写的定位失效</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge4j4z8.html">spring boot &plus; neo4j restful</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge4jvl8.html">php的autoload机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdkwr79.html">webservice中采用协议Http&comma;它是指什么意思</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ydpxn8.html">iOS JsonModel</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jznnl08.html">决策树ID3算法的java实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdkk079.html">NYoj1058</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy0we8.html">LPC1788的EMC驱动norflash</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
